/* --- The following code comes from C:\lcc\lib\wizard\dll.tpl. */
#include <stdio.h>
#include <windows.h>
#include <math.h>
/*------------------------------------------------------------------------
 Procedure:     LibMain ID:1
 Purpose:       Dll entry point.Called when a dll is loaded or
                unloaded by a process, and when new threads are
                created or destroyed.
 Input:         hDllInst: Instance handle of the dll
                fdwReason: event: attach/detach
                lpvReserved: not used
 Output:        The return value is used only when the fdwReason is
                DLL_PROCESS_ATTACH. True means that the dll has
                sucesfully loaded, False means that the dll is unable
                to initialize and should be unloaded immediately.
 Errors:
------------------------------------------------------------------------*/
BOOL WINAPI __declspec(dllexport) LibMain(HINSTANCE hDLLInst, DWORD fdwReason, LPVOID lpvReserved)
{
    switch (fdwReason)
    {
        case DLL_PROCESS_ATTACH:
            // The DLL is being loaded for the first time by a given process.
            // Perform per-process initialization here.  If the initialization
            // is successful, return TRUE; if unsuccessful, return FALSE.


            break;
        case DLL_PROCESS_DETACH:
            // The DLL is being unloaded by a given process.  Do any
            // per-process clean up here, such as undoing what was done in
            // DLL_PROCESS_ATTACH.  The return value is ignored.


            break;
        case DLL_THREAD_ATTACH:
            // A thread is being created in a process that has already loaded
            // this DLL.  Perform any per-thread initialization here.  The
            // return value is ignored.

            break;
        case DLL_THREAD_DETACH:
            // A thread is exiting cleanly in a process that has already
            // loaded this DLL.  Perform any per-thread clean up here.  The
            // return value is ignored.

            break;
    }
    return TRUE;
}

void __declspec (dllexport) transform(double *x, double *y, double theta)
{
    double c;
    double s;
    double x_tmp;

    x_tmp = *x;
    c = cos(theta);
    s = sin(theta);
    *x = x_tmp*c + *y*s;
    *y = *y*c - x_tmp*s;
    return;
}


void __declspec (dllexport) transform_array(double X[], double Y[], double THETA[], double *x, double *y, long N)
{
          long i;
          double c, s;

          for (i=0; i<N; i++){
              c = cos(THETA[i]);
              s = sin(THETA[i]);
              *x = X[i]*c + Y[i]*s;
              *y = Y[i]*c - X[i]*s;
          }
          return;
}
